searchNodes=[{"type":"module","title":"stk500","doc":"","ref":"stk500.html"},{"type":"function","title":"stk500.chunk/2","doc":"","ref":"stk500.html#chunk/2"},{"type":"function","title":"stk500.cmd/2","doc":"","ref":"stk500.html#cmd/2"},{"type":"function","title":"stk500.cmd/3","doc":"","ref":"stk500.html#cmd/3"},{"type":"function","title":"stk500.dtrrts/2","doc":"","ref":"stk500.html#dtrrts/2"},{"type":"function","title":"stk500.hex_file/1","doc":"Read a hex file generated by the Arduino IDE hex_file/1 returns a list of binaries as read from the % file (16 bytes). It's faster to use 128 bytes chunks.","ref":"stk500.html#hex_file/1"},{"type":"function","title":"stk500.hex_file/2","doc":"","ref":"stk500.html#hex_file/2"},{"type":"function","title":"stk500.load/2","doc":"Load the hex file","ref":"stk500.html#load/2"},{"type":"function","title":"stk500.load/3","doc":"","ref":"stk500.html#load/3"},{"type":"function","title":"stk500.open/0","doc":"Connect to the Arduino using the default serial device at 19200 baud","ref":"stk500.html#open/0"},{"type":"function","title":"stk500.open/1","doc":"Connect to the Arduino using the specified serial device at 19200 baud","ref":"stk500.html#open/1"},{"type":"function","title":"stk500.open/2","doc":"Connect to the Arduino using the specified serial device and settings % The Diecimila uses 19200 { ok , FD } = stk500 : open ( &quot;/dev/ttyUSB0&quot; , [ { speed , 19200 } ] ) .","ref":"stk500.html#open/2"},{"type":"function","title":"stk500.reset/1","doc":"Reset the Arduino","ref":"stk500.html#reset/1"},{"type":"function","title":"stk500.serial_device/0","doc":"Try to discover the serial device Lookup the serial device in an environment variable: STK500_SERIAL_PORT Defaults to: /dev/ttyUSB0","ref":"stk500.html#serial_device/0"},{"type":"function","title":"stk500.sync/1","doc":"","ref":"stk500.html#sync/1"},{"type":"function","title":"stk500.version/1","doc":"Get version","ref":"stk500.html#version/1"},{"type":"extras","title":"Overview","doc":"stk500 is an Erlang implementation of enough of the STK500 protocol to talk to an Arduino.","ref":"readme.html"},{"type":"extras","title":"Overview - Example","doc":"% Open the serial device attached to the Arduino % The Diecimila uses 19200 { ok , FD } = stk500 :open ( &quot;/dev/ttyUSB0&quot; , [ { speed , 19200 } ] ) , % Read a hex file generated by the Arduino IDE % % hex_file / 1 returns a list of binaries as read from the % file ( 16 bytes ) . It &#39; s faster to use 128 bytes chunks . Hex = stk500 :hex_file ( &quot;test/counter.cpp.hex&quot; ) , Bytes = stk500 :chunk ( Hex , 128 ) , ok = stk500 :load ( FD , Bytes ) , stk500 :close ( FD ) . test/counter.cpp.hex is a compiled hex file for testing, generated from the example in examples/counter/counter.pde. To call the example code from Erlang: 1 &gt; counter :run ( ) . % loops adding 1 to a counter 2 &gt; { ok , FD } = counter :start ( &quot;/dev/ttyUSB0&quot; ) . 3 &gt; counter :read ( FD ) . { ok , 0 } 4 &gt; counter :incr ( FD ) . ok 5 &gt; counter :incr ( FD , 5 ) . 6 &gt; counter :read ( FD ) . { ok , 6 } 7 &gt; counter :set ( FD , 3 ) . ok 8 &gt; counter :read ( FD ) . { ok , 3 }","ref":"readme.html#example"},{"type":"extras","title":"Overview - Build","doc":"$ rebar3 compile # running tests # arduino is attached to /dev/ttyUSB2 STK500_SERIAL_PORT=/dev/ttyUSB2 rebar3 ct","ref":"readme.html#build"},{"type":"extras","title":"Overview - Note on Protocol Dumping","doc":"The simplest way to dump the serial communications is by using strace. For example, on an Ubuntu system, to see how the Arduino IDE is calling avrdude: # as root cd / usr / share / arduino / hardware / tools mv avrdude avrdude . dist cat &lt;&lt; EOF &gt; avrdude #!/bin/sh set - e mkdir / tmp / arduino - $ $ strace - e read = 3 - e write = 3 - v - o / tmp / arduino - $ $ / dump \\ - e trace = open , close , read , write , ioctl \\ / usr / share / arduino / hardware / tools / avrdude . dist $ @ EOF An example protocol dump is doc/protocol_trace.txt.","ref":"readme.html#note-on-protocol-dumping"},{"type":"extras","title":"Overview - Resources","doc":"The STK500 protocol documentation can be found here: http :// www . atmel . com / Images / doc2525 . pdf","ref":"readme.html#resources"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2012-2022, Michael Santos &lt;michael.santos@gmail.com&gt; Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies. THE SOFTWARE IS PROVIDED &quot;AS IS&quot; AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.","ref":"license.html"}]